'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');
var reactNative = require('react-native');

/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0

THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.

See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */
/* global Reflect, Promise */

var extendStatics = function(d, b) {
    extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return extendStatics(d, b);
};

function __extends(d, b) {
    extendStatics(d, b);
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
}

var Mount = /** @class */ (function (_super) {
    __extends(Mount, _super);
    function Mount() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Mount.prototype.componentDidMount = function () {
        var on = this.props.on;
        on(this.props);
    };
    Mount.prototype.render = function () {
        var children = this.props.children;
        return children;
    };
    return Mount;
}(React.Component));

function shallowEquals(prevWatched, currentWatched) {
    if (typeof prevWatched !== "object") {
        return prevWatched === currentWatched;
    }
    var prevValuesKeys = Object.keys(prevWatched);
    var currentValuesKeys = Object.keys(currentWatched);
    if (prevValuesKeys.length !== currentValuesKeys.length) {
        return false;
    }
    return prevValuesKeys.every(function (key) { return prevWatched[key] === currentWatched[key]; });
}
var Update = /** @class */ (function (_super) {
    __extends(Update, _super);
    function Update() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Update.prototype.componentDidUpdate = function (prevProps) {
        var was = this.props.was;
        if (!shallowEquals(prevProps.watched, this.props.watched)) {
            was(prevProps.watched, this.props.watched);
        }
    };
    Update.prototype.render = function () {
        var children = this.props.children;
        return children;
    };
    return Update;
}(React.Component));

var AnimationContext = React.createContext({});

var Context = React.createContext({});

var Consumer = Context.Consumer;

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function _extends() {
  _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  return _extends.apply(this, arguments);
}

function _objectSpread(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};
    var ownKeys = Object.keys(source);

    if (typeof Object.getOwnPropertySymbols === 'function') {
      ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) {
        return Object.getOwnPropertyDescriptor(source, sym).enumerable;
      }));
    }

    ownKeys.forEach(function (key) {
      _defineProperty(target, key, source[key]);
    });
  }

  return target;
}

function _inheritsLoose(subClass, superClass) {
  subClass.prototype = Object.create(superClass.prototype);
  subClass.prototype.constructor = subClass;
  subClass.__proto__ = superClass;
}

function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;

  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }

  return target;
}

function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return self;
}

var mapWith = function mapWith(map, transform) {
  return Object.keys(map).reduce(function (final, key) {
    var _objectSpread2;

    return _objectSpread({}, final, (_objectSpread2 = {}, _objectSpread2[key] = transform(map[key], key), _objectSpread2));
  }, {});
};

var mapSetStateToActions = function mapSetStateToActions(setState, actionMap) {
  return mapWith(actionMap, function (action, type) {
    return function () {
      return setState(action.apply(void 0, arguments), undefined, type);
    };
  });
};
var mapStateToSelectors = function mapStateToSelectors(state, selectorMap) {
  return mapWith(selectorMap, function (selector) {
    return function () {
      return selector.apply(void 0, arguments)(state);
    };
  });
};
var mapPropsToEffects = function mapPropsToEffects(getEffectProps, effectMap) {
  return mapWith(effectMap, function (effect, type) {
    return function () {
      return effect.apply(void 0, arguments)(getEffectProps(type));
    };
  });
}; // _ is a temporary fix for eslint parser

var parseUpdater = function parseUpdater(updaterOrState, state) {
  return typeof updaterOrState === "function" ? updaterOrState(state) : updaterOrState;
};

var InnerContainer =
/*#__PURE__*/
function (_React$Component) {
  _inheritsLoose(InnerContainer, _React$Component);

  function InnerContainer(props) {
    var _this;

    _this = _React$Component.call(this, props) || this;

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "state", _this.props.initialState);

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "ignoreState", false);

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "unmount", undefined);

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "getEffectProps", function (type) {
      var _this$props = _this.props,
          context = _this$props.context,
          state = _this$props.state;
      return {
        state: context && state ? state : _this.state,
        setState: function setState(u, c) {
          return _this.handleSetState(u, c, type);
        }
      };
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "handleSetState", function (updater, callback, type) {
      var _this$props2 = _this.props,
          context = _this$props2.context,
          setContextState = _this$props2.setContextState;
      var prevState;

      var updaterFn = function updaterFn(state) {
        prevState = state;
        return parseUpdater(updater, state);
      };

      var callbackFn = function callbackFn() {
        var _this$props3 = _this.props,
            _this$props3$state = _this$props3.state,
            state = _this$props3$state === void 0 ? _this.state : _this$props3$state,
            onUpdate = _this$props3.onUpdate;

        if (onUpdate && _this.ignoreState !== state) {
          onUpdate(_objectSpread({}, _this.getEffectProps("onUpdate"), {
            prevState: prevState,
            type: type
          }));
        }

        if (callback) callback();
      };

      if (context && setContextState) {
        setContextState(context, updaterFn, callbackFn, type);
      } else {
        // @ts-ignore
        _this.setState(updaterFn, callbackFn);
      }
    });

    var _context = props.context,
        _setContextState = props.setContextState,
        _state = props.state,
        initialState = props.initialState;

    if (_context && _setContextState && !_state) {
      _setContextState(_context, function (currentState) {
        return Object.assign({}, initialState, currentState);
      }, undefined, "initialState");
    }

    return _this;
  }

  var _proto = InnerContainer.prototype;

  _proto.componentDidMount = function componentDidMount() {
    var _this2 = this;

    var _this$props4 = this.props,
        context = _this$props4.context,
        mountContainer = _this$props4.mountContainer,
        onMount = _this$props4.onMount;

    var mount = function mount() {
      return onMount && onMount(_this2.getEffectProps("onMount"));
    };

    if (context && mountContainer) {
      this.unmount = mountContainer(context, mount);
    } else if (!context) {
      mount();
    }
  };

  _proto.shouldComponentUpdate = function shouldComponentUpdate(nextProps, nextState) {
    var _this$props5 = this.props,
        context = _this$props5.context,
        stateFromProps = _this$props5.state;
    var nextStateFromProps = nextProps.state,
        shouldUpdate = nextProps.shouldUpdate;
    var couldUpdate = true;

    if (context && stateFromProps && nextStateFromProps && shouldUpdate) {
      couldUpdate = shouldUpdate({
        state: stateFromProps,
        nextState: nextStateFromProps
      });
      this.ignoreState = !couldUpdate && nextStateFromProps;
    } else if (!context && shouldUpdate) {
      couldUpdate = shouldUpdate({
        state: this.state,
        nextState: nextState
      });
      this.ignoreState = !couldUpdate && nextState;
    }

    return couldUpdate;
  };

  _proto.componentWillUnmount = function componentWillUnmount() {
    var _this3 = this;

    var _this$props6 = this.props,
        context = _this$props6.context,
        onUnmount = _this$props6.onUnmount;

    var unmount = function unmount() {
      return onUnmount && onUnmount(_this3.getEffectProps("onUnmount"));
    };

    if (this.unmount) {
      this.unmount(unmount);
    } else if (!context) {
      unmount();
    }
  };

  _proto.render = function render() {
    var _this$props7 = this.props,
        state = _this$props7.state,
        children = _this$props7.children,
        actions = _this$props7.actions,
        selectors = _this$props7.selectors,
        effects = _this$props7.effects;
    var childrenProps = Object.assign({}, state || this.state, actions && mapSetStateToActions(this.handleSetState, actions), selectors && mapStateToSelectors(state || this.state, selectors), effects && mapPropsToEffects(this.getEffectProps, effects));
    return children(childrenProps);
  };

  return InnerContainer;
}(React.Component); // eslint-disable-next-line react/prefer-stateless-function, react/no-multi-comp


_defineProperty(InnerContainer, "defaultProps", {
  initialState: {}
});

var Container =
/*#__PURE__*/
function (_React$Component2) {
  _inheritsLoose(Container, _React$Component2);

  function Container() {
    return _React$Component2.apply(this, arguments) || this;
  }

  var _proto2 = Container.prototype;

  _proto2.render = function render() {
    var _this4 = this;

    var context = this.props.context;

    if (typeof context !== "undefined") {
      return React.createElement(Consumer, null, function (_ref) {
        var state = _ref.state,
            setContextState = _ref.setContextState,
            mountContainer = _ref.mountContainer;
        return React.createElement(InnerContainer, _extends({}, _this4.props, {
          state: state[context],
          setContextState: setContextState,
          mountContainer: mountContainer
        }));
      });
    }

    return React.createElement(InnerContainer, this.props);
  };

  return Container;
}(React.Component);

var reduxDevtoolsExtension = typeof window !== "undefined" && window.__REDUX_DEVTOOLS_EXTENSION__;

var Provider =
/*#__PURE__*/
function (_React$Component) {
  _inheritsLoose(Provider, _React$Component);

  function Provider(props) {
    var _this;

    _this = _React$Component.call(this, props) || this;

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "containers", {});

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "devtools", void 0);

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "mountContainer", function (context, onMount) {
      if (!_this.containers[context]) {
        _this.containers[context] = 0;
        if (onMount) _this.setState(null, onMount);
      }

      _this.containers[context] += 1;
      return function (onUnmount) {
        if (_this.containers[context] === 1 && onUnmount) onUnmount();
        _this.containers[context] -= 1;
      };
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "setContextState", function (context, updater, callback, type) {
      var prevState;

      var updaterFn = function updaterFn(state) {
        var _Object$assign;

        prevState = state.state;
        return {
          state: Object.assign({}, state.state, (_Object$assign = {}, _Object$assign[context] = Object.assign({}, state.state[context], parseUpdater(updater, state.state[context] || {})), _Object$assign))
        };
      };

      var callbackFn = function callbackFn() {
        if (_this.props.onUpdate) {
          var onUpdateProps = _objectSpread({}, _this.getProps("Provider/onUpdate"), {
            prevState: prevState,
            context: context,
            type: type
          });

          _this.props.onUpdate(onUpdateProps);
        }

        if (callback) callback(); // istanbul ignore next

        if (_this.devtools && type) {
          var devtoolsType = context ? context + "/" + type : type;

          _this.devtools.send(devtoolsType, _this.state.state);
        }
      }; // @ts-ignore


      _this.setState(updaterFn, callbackFn);
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "getProps", function (type) {
      var _this$state = _this.state,
          state = _this$state.state,
          setContextState = _this$state.setContextState;
      return {
        state: state,
        setContextState: function (_setContextState) {
          function setContextState(_x, _x2, _x3) {
            return _setContextState.apply(this, arguments);
          }

          setContextState.toString = function () {
            return _setContextState.toString();
          };

          return setContextState;
        }(function (context, updater, callback) {
          return setContextState(context, updater, callback, type);
        })
      };
    });

    var devtools = props.devtools,
        initialState = props.initialState;
    _this.state = {
      state: initialState,
      mountContainer: _this.mountContainer,
      setContextState: _this.setContextState
    }; // istanbul ignore next

    if (devtools && reduxDevtoolsExtension) {
      _this.devtools = reduxDevtoolsExtension.connect({
        name: "Context"
      });

      _this.devtools.init(initialState);

      _this.devtools.subscribe(function (message) {
        if (message.type === "DISPATCH" && message.state) {
          _this.setState(function (state) {
            return {
              state: Object.assign({}, state.state, JSON.parse(message.state))
            };
          });
        }
      });
    }

    return _this;
  }

  var _proto = Provider.prototype;

  _proto.componentDidMount = function componentDidMount() {
    if (this.props.onMount) {
      this.props.onMount(this.getProps("Provider/onMount"));
    }
  };

  _proto.componentWillUnmount = function componentWillUnmount() {
    if (this.props.onUnmount) {
      var _this$getProps = this.getProps(),
          _setContextState2 = _this$getProps.setContextState,
          args = _objectWithoutPropertiesLoose(_this$getProps, ["setContextState"]);

      this.props.onUnmount(args);
    } // istanbul ignore next


    if (this.devtools && reduxDevtoolsExtension) {
      this.devtools.unsubscribe();
      reduxDevtoolsExtension.disconnect();
    }
  };

  _proto.render = function render() {
    return (// @ts-ignore
      React.createElement(Context.Provider, {
        value: this.state
      }, this.props.children)
    );
  };

  return Provider;
}(React.Component);

_defineProperty(Provider, "defaultProps", {
  initialState: {}
});

function d(n){var r=typeof n;if(null===n)return "Null";if(void 0===n)return "Undefined";if("boolean"===r)return "Boolean";if("number"===r)return "Number";if("string"===r)return "String";if(Array.isArray(n))return "Array";if(n instanceof RegExp)return "RegExp";var t=n.toString();return t.startsWith("async")?"Async":"[object Promise]"===t?"Promise":t.includes("function")||t.includes("=>")?"Function":"Object"}function y(n,r){if(1===arguments.length)return function(r){return y(n,r)};if(n===r)return !0;var t=d(n);if(t!==d(r))return !1;if("Array"===t){var u=Array.from(n),e=Array.from(r);if(u.toString()!==e.toString())return !1;var i=!0;return u.forEach(function(n,r){i&&(n===e[r]||y(n,e[r])||(i=!1));}),i}if("Object"===t){var o=Object.keys(n);if(o.length!==Object.keys(r).length)return !1;var f=!0;return o.forEach(function(t){if(f){var u=n[t],e=r[t];u===e||y(u,e)||(f=!1);}}),f}return !1}function b(n,r){if(1===arguments.length)return function(r){return b(n,r)};for(var t=-1,u=!1;++t<r.length&&!u;)y(r[t],n)&&(u=!0);return u}function Sn(n,r,t){return void 0===r?function(r,t){return Sn(n,r,t)}:void 0===t?function(t){return Sn(n,r,t)}:t.reduce(n,r)}function Vn(n,r){return Sn(function(r,t){return b(t,n)?r:r.concat(t)},[],r)}

var initialState = {
    animations: [],
};
var actions = {
    addAnimation: function (animation) { return function (state) { return ({
        animations: state.animations.concat([animation]),
    }); }; },
    removeAnimations: function (animations) { return function (state) { return ({
        animations: Vn(animations, state.animations),
    }); }; },
};
var AnimationState = function (_a) {
    var children = _a.children;
    return (React.createElement(Container, { actions: actions, initialState: initialState }, children));
};

var RunnerHandler = function (_a) {
    var children = _a.children, getRunner = _a.getRunner, shouldStart = _a.shouldStart;
    return (React.createElement(AnimationContext.Consumer, null, function (_a) {
        var upperAddAnimation = _a.addAnimation;
        return (React.createElement(AnimationState, null, function (_a) {
            var addAnimation = _a.addAnimation, removeAnimations = _a.removeAnimations, animations = _a.animations;
            return (React.createElement(Update, { watched: { animations: animations, shouldStart: shouldStart }, was: function () {
                    if (animations.length !== 0 && shouldStart) {
                        if (upperAddAnimation) {
                            upperAddAnimation(getRunner(animations));
                        }
                        else {
                            getRunner(animations).start();
                        }
                        removeAnimations(animations);
                    }
                } },
                React.createElement(AnimationContext.Provider, { value: { addAnimation: addAnimation } }, children)));
        }));
    }));
};

var Parallel = function (_a) {
    var children = _a.children, _b = _a.shouldStart, shouldStart = _b === void 0 ? true : _b;
    return (React.createElement(RunnerHandler, { shouldStart: shouldStart, getRunner: function (animations) { return reactNative.Animated.parallel(animations); } }, children));
};

var Sequence = function (_a) {
    var children = _a.children, _b = _a.shouldStart, shouldStart = _b === void 0 ? true : _b;
    return (React.createElement(RunnerHandler, { shouldStart: shouldStart, getRunner: function (animations) { return reactNative.Animated.sequence(animations); } }, children));
};

var Loop = function (_a) {
    var children = _a.children, _b = _a.shouldStart, shouldStart = _b === void 0 ? true : _b, iterations = _a.iterations;
    return (React.createElement(RunnerHandler, { shouldStart: shouldStart, getRunner: function (animations) {
            return reactNative.Animated.loop(reactNative.Animated.parallel(animations), {
                iterations: iterations,
            });
        } }, children));
};

var AnimationValueProvider = function (_a) {
    var children = _a.children, initialValue = _a.initialValue;
    return (React.createElement(Container, { initialState: { animatedValue: new reactNative.Animated.Value(initialValue) } }, children));
};

var AnimationHandler = function (_a) {
    var initialValue = _a.initialValue, toValue = _a.toValue, getAnimation = _a.getAnimation, _b = _a.children, children = _b === void 0 ? null : _b;
    return (React.createElement(AnimationValueProvider, { initialValue: initialValue }, function (_a) {
        var animatedValue = _a.animatedValue;
        return (React.createElement(AnimationContext.Consumer, null, function (_a) {
            var _b = _a.addAnimation, addAnimation = _b === void 0 ? function () {
                console.error('You are trying to run an animation without a runner.');
            } : _b;
            return (React.createElement(Mount, { on: function () { return addAnimation(getAnimation(animatedValue)); } },
                React.createElement(Update, { was: function () { return addAnimation(getAnimation(animatedValue)); }, watched: toValue }, typeof children === 'function'
                    ? children(animatedValue)
                    : children)));
        }));
    }));
};

var Timing = function (_a) {
    var children = _a.children, toValue = _a.toValue, initialValue = _a.initialValue, _b = _a.config, easing = _b.easing, duration = _b.duration, delay = _b.delay, isInteraction = _b.isInteraction, _c = _b.useNativeDriver, useNativeDriver = _c === void 0 ? true : _c;
    return (React.createElement(AnimationHandler, { toValue: toValue, getAnimation: function (animatedValue) {
            return reactNative.Animated.timing(animatedValue, {
                toValue: toValue,
                easing: easing,
                duration: duration,
                delay: delay,
                isInteraction: isInteraction,
                useNativeDriver: useNativeDriver,
            });
        }, initialValue: initialValue }, children));
};

var Spring = function (_a) {
    var children = _a.children, toValue = _a.toValue, initialValue = _a.initialValue, _b = _a.config, overshootClamping = _b.overshootClamping, restDisplacementThreshold = _b.restDisplacementThreshold, restSpeedThreshold = _b.restSpeedThreshold, velocity = _b.velocity, bounciness = _b.bounciness, speed = _b.speed, tension = _b.tension, friction = _b.friction, stiffness = _b.stiffness, mass = _b.mass, damping = _b.damping, isInteraction = _b.isInteraction, _c = _b.useNativeDriver, useNativeDriver = _c === void 0 ? true : _c;
    return (React.createElement(AnimationHandler, { toValue: toValue, getAnimation: function (animatedValue) {
            return reactNative.Animated.spring(animatedValue, {
                overshootClamping: overshootClamping,
                restDisplacementThreshold: restDisplacementThreshold,
                restSpeedThreshold: restSpeedThreshold,
                velocity: velocity,
                bounciness: bounciness,
                speed: speed,
                tension: tension,
                friction: friction,
                stiffness: stiffness,
                mass: mass,
                damping: damping,
                toValue: toValue,
                isInteraction: isInteraction,
                useNativeDriver: useNativeDriver,
            });
        }, initialValue: initialValue }, children));
};

var Delay = function (_a) {
    var _b = _a.config, _c = (_b === void 0 ? {} : _b).delay, delay = _c === void 0 ? 0 : _c;
    return (React.createElement(AnimationContext.Consumer, null, function (_a) {
        var addAnimation = _a.addAnimation;
        return (React.createElement(Mount, { on: function () {
                if (delay !== 0) {
                    addAnimation(reactNative.Animated.delay(delay));
                }
            } },
            React.createElement(Update, { watched: { delay: delay }, was: function () {
                    if (delay !== 0) {
                        addAnimation(reactNative.Animated.delay(delay));
                    }
                } }, null)));
    }));
};

var Gate = function (_a) {
    var children = _a.children;
    return (React.createElement(AnimationContext.Provider, { value: {} }, children));
};

exports.Parallel = Parallel;
exports.Sequence = Sequence;
exports.Loop = Loop;
exports.Timing = Timing;
exports.Spring = Spring;
exports.Delay = Delay;
exports.Gate = Gate;
exports.AnimationValueProvider = AnimationValueProvider;
